CREATE OR REPLACE PROCEDURE LIMPEZA_LANCCONT(
   P_NRLISTA           IN VARCHAR2,
   P_DTLANC            IN LANCCONT.DTLANCCONT%TYPE,
   P_DSSISTLIMPEZ      IN VARCHAR2,   
   P_NMOPERLIMPEZ      IN VARCHAR2,
   P_IDSISTEMA         IN VARCHAR2)   
IS
   V_DTHRFINLIMPEZA    DATE;    
   V_NRORDEM           VARCHAR2(03);
   
   V_COUNT_COMMIT      NUMBER := 1;
   V_NUM_TO_COMMIT     NUMBER := 1000;
   
   V_EXCLUILANCCONT    NUMBER := 0;
   V_EXCLUISALDEMPR    NUMBER := 0;
   V_EXCLUILOGLANCONT  NUMBER := 0;
   V_EXCLUISALDCOME    NUMBER := 0;
   V_EXCLUISALDCCUS    NUMBER := 0;
   
   V_DSIP              VARCHAR2(50);
   V_DSUSUARIO         VARCHAR2(50);
   V_DSRDM             VARCHAR2(50);
   V_DSMETODO          VARCHAR2(250);
   V_DSOPERADOR        VARCHAR2(12);
   V_ERR0R             VARCHAR2(2000);   
   V_PASSO             NUMBER := 0;   
   
   
   PROCEDURE VERIFTIMEOUT(DTLIMITE IN DATE) IS
   BEGIN
      IF SYSDATE > DTLIMITE THEN
         RAISE_APPLICATION_ERROR(-20001,'TIMEOUT - EXCEO PROPOSITAL TEKNISA');
      END IF;
   END;
BEGIN
   DELETE FROM TRABPROCLIMPEZA
   WHERE IDLIMPEZA = P_IDSISTEMA;

   V_NRORDEM := '0';

   UPDATE TRABLIMPEZA
   SET IDSTATUSLIMPEZA = 'A'
   WHERE IDLIMPEZA = P_IDSISTEMA; 
   
   --PEGA A DATA INICIAL E FINAL DA EXECUO
   SELECT TO_DATE(TO_CHAR(SYSDATE,'DDMMYYYY') || HRFINLIMPEZA||'00','DDMMYYYYHH24MISS')
   INTO V_DTHRFINLIMPEZA
   FROM TRABLIMPEZA
   WHERE IDLIMPEZA = P_IDSISTEMA;
    
   IF V_DTHRFINLIMPEZA <= SYSDATE THEN
      V_DTHRFINLIMPEZA := V_DTHRFINLIMPEZA + 1;
   END IF;   

   COMMIT;
   
   WEBTUNNING(V_DSIP, V_DSUSUARIO, V_DSRDM, V_DSMETODO,  V_DSOPERADOR);
   
   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM) + 1), 3, '0');
   
   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = P_IDSISTEMA
      AND NMTABELALIMP = 'LANCCONT'; 
      
   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
      VALUES
      (P_IDSISTEMA, 'LANCCONT', V_NRORDEM);
   END IF;  
   
   INSERT INTO TRABPROCLIMPEZA
     (IDLIMPEZA, NMTABELALIMP)
   VALUES
      (P_IDSISTEMA, 'LANCCONT');

   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM) + 1), 3, '0');
   
   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = P_IDSISTEMA
      AND NMTABELALIMP = 'SALDEMPR'; 
      
   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
      VALUES
      (P_IDSISTEMA, 'SALDEMPR', V_NRORDEM);
   END IF;  

   INSERT INTO TRABPROCLIMPEZA
     (IDLIMPEZA, NMTABELALIMP)
   VALUES
      (P_IDSISTEMA, 'SALDEMPR');

   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM) + 1), 3, '0');
   
   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = P_IDSISTEMA
      AND NMTABELALIMP = 'LOGLANCONT'; 
      
   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
      VALUES
      (P_IDSISTEMA, 'LOGLANCONT', V_NRORDEM);
   END IF;  

   INSERT INTO TRABPROCLIMPEZA
     (IDLIMPEZA, NMTABELALIMP)
   VALUES
      (P_IDSISTEMA, 'LOGLANCONT');

   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM) + 1), 3, '0');
   
   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = P_IDSISTEMA
      AND NMTABELALIMP = 'SALDCOME'; 
      
   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
      VALUES
      (P_IDSISTEMA, 'SALDCOME', V_NRORDEM);  
   END IF;  
   
   INSERT INTO TRABPROCLIMPEZA
     (IDLIMPEZA, NMTABELALIMP)
   VALUES
      (P_IDSISTEMA, 'SALDCOME');
   
   V_NRORDEM := LPAD(TO_CHAR(TO_NUMBER(V_NRORDEM) + 1), 3, '0');
   
   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = V_NRORDEM
    WHERE IDLIMPEZA = P_IDSISTEMA
      AND NMTABELALIMP = 'SALDCCUS'; 
      
   IF NOT(SQL%ROWCOUNT > 0) THEN
      INSERT INTO TABLIMPEZA
      VALUES
      (P_IDSISTEMA, 'SALDCCUS', V_NRORDEM);
   END IF;        
   
   INSERT INTO TRABPROCLIMPEZA
     (IDLIMPEZA, NMTABELALIMP)
   VALUES
      (P_IDSISTEMA, 'SALDCCUS');
      
   V_PASSO := 1;
   
   FOR C_LISTA IN (SELECT CDLISTA AS CDEMPRESA
                     FROM LISTA
                    WHERE NRLISTA = P_NRLISTA) LOOP

      V_COUNT_COMMIT := 0;
      FOR C_LANCCONT IN (SELECT ROWID AS LINHA
                           FROM LANCCONT
                          WHERE CDEMPRESA   = C_LISTA.CDEMPRESA
                            AND DTLANCCONT <= P_DTLANC) LOOP
                         
         DELETE LANCCONT
          WHERE ROWID = C_LANCCONT.LINHA;
          
         V_EXCLUILANCCONT := SQL%ROWCOUNT + V_EXCLUILANCCONT;
         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN
            UPDATE TRABPROCLIMPEZA
               SET QTREGEXCLIMPEZA = V_EXCLUILANCCONT
             WHERE IDLIMPEZA       = P_IDSISTEMA
               AND NMTABELALIMP    = 'LANCCONT';
             
            COMMIT;
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         ELSE
            V_COUNT_COMMIT := V_COUNT_COMMIT + 1;
         END IF;
      END LOOP;
      
      V_PASSO := 2;
      V_COUNT_COMMIT := 0;
      FOR C_SALDEMPR IN (SELECT ROWID AS LINHA
                           FROM SALDEMPR
                          WHERE CDEMPRESA  = C_LISTA.CDEMPRESA
                            AND DTSALDEMPR <= P_DTLANC) LOOP
                         
         DELETE SALDEMPR
          WHERE ROWID = C_SALDEMPR.LINHA;
          
         V_EXCLUISALDEMPR := SQL%ROWCOUNT + V_EXCLUISALDEMPR;
         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN
            UPDATE TRABPROCLIMPEZA
               SET QTREGEXCLIMPEZA = V_EXCLUISALDEMPR
             WHERE IDLIMPEZA       = P_IDSISTEMA
               AND NMTABELALIMP    = 'SALDEMPR';
             
            COMMIT;
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         ELSE
            V_COUNT_COMMIT := V_COUNT_COMMIT + 1;
         END IF;
      END LOOP;

      V_PASSO := 3;
      V_COUNT_COMMIT := 0;
      FOR C_LOGLANCONT IN (SELECT ROWID AS LINHA
                             FROM LOGLANCONT
                            WHERE CDEMPRLOG = C_LISTA.CDEMPRESA
                              AND DTLANCLOG <= P_DTLANC) LOOP
                         
         DELETE LOGLANCONT
          WHERE ROWID = C_LOGLANCONT.LINHA;
          
         V_EXCLUILOGLANCONT := SQL%ROWCOUNT + V_EXCLUILOGLANCONT;
         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN
            UPDATE TRABPROCLIMPEZA
               SET QTREGEXCLIMPEZA = V_EXCLUILOGLANCONT
             WHERE IDLIMPEZA       = P_IDSISTEMA
               AND NMTABELALIMP    = 'LOGLANCONT';
             
            COMMIT;
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         ELSE
            V_COUNT_COMMIT := V_COUNT_COMMIT + 1;
         END IF;
      END LOOP;    

      V_PASSO := 4;
      V_COUNT_COMMIT := 0;
      FOR C_SALDCOME IN (SELECT ROWID AS LINHA
                           FROM SALDCOME
                          WHERE CDEMPRESA  = C_LISTA.CDEMPRESA
                            AND DTSALDCOME <= P_DTLANC) LOOP
                         
         DELETE SALDCOME
          WHERE ROWID = C_SALDCOME.LINHA;
          
         V_EXCLUISALDCOME := SQL%ROWCOUNT + V_EXCLUISALDCOME;
         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN
            UPDATE TRABPROCLIMPEZA
               SET QTREGEXCLIMPEZA = V_EXCLUISALDCOME
             WHERE IDLIMPEZA       = P_IDSISTEMA
               AND NMTABELALIMP    = 'SALDCOME';
             
            COMMIT;
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         ELSE
            V_COUNT_COMMIT := V_COUNT_COMMIT + 1;
         END IF;
      END LOOP;   

      V_PASSO := 5;
      V_COUNT_COMMIT := 0;
      FOR C_SALDCCUS IN (SELECT ROWID AS LINHA
                           FROM SALDCCUS
                          WHERE CDEMPRESA  = C_LISTA.CDEMPRESA
                            AND DTSALDCCUS <= P_DTLANC) LOOP
                         
         DELETE SALDCCUS
          WHERE ROWID = C_SALDCCUS.LINHA;
          
         V_EXCLUISALDCCUS := SQL%ROWCOUNT + V_EXCLUISALDCCUS;
         IF V_COUNT_COMMIT >= V_NUM_TO_COMMIT THEN
            UPDATE TRABPROCLIMPEZA
               SET QTREGEXCLIMPEZA = V_EXCLUISALDCCUS
             WHERE IDLIMPEZA       = P_IDSISTEMA
               AND NMTABELALIMP    = 'SALDCCUS';
             
            COMMIT;
            VERIFTIMEOUT(V_DTHRFINLIMPEZA);
         ELSE
            V_COUNT_COMMIT := V_COUNT_COMMIT + 1;
         END IF;
      END LOOP;    
   END LOOP; /*C_LISTA*/
   
   V_PASSO := 6;

   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP  = 'C',
          QTREGEXCLIMPEZA = V_EXCLUILANCCONT,
          DTHRFINLIMPEZA  = SYSDATE
    WHERE IDLIMPEZA    = P_IDSISTEMA
      AND NMTABELALIMP = 'LANCCONT';

   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP  = 'C',
          QTREGEXCLIMPEZA = V_EXCLUISALDEMPR,
          DTHRFINLIMPEZA  = SYSDATE
    WHERE IDLIMPEZA    = P_IDSISTEMA
      AND NMTABELALIMP = 'SALDEMPR';

   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP  = 'C',
          QTREGEXCLIMPEZA = V_EXCLUILOGLANCONT,
          DTHRFINLIMPEZA  = SYSDATE
    WHERE IDLIMPEZA    = P_IDSISTEMA
      AND NMTABELALIMP = 'LOGLANCONT';

   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP  = 'C',
          QTREGEXCLIMPEZA = V_EXCLUISALDCOME,
          DTHRFINLIMPEZA  = SYSDATE
    WHERE IDLIMPEZA    = P_IDSISTEMA
      AND NMTABELALIMP = 'SALDCOME';

   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP  = 'C',
          QTREGEXCLIMPEZA = V_EXCLUISALDCCUS,
          DTHRFINLIMPEZA  = SYSDATE
    WHERE IDLIMPEZA    = P_IDSISTEMA
      AND NMTABELALIMP = 'SALDCCUS';
      
   UPDATE TRABLIMPEZA
      SET IDSTATUSLIMPEZA = 'C'
    WHERE IDLIMPEZA = P_IDSISTEMA;
    
   COMMIT;
      
   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     (P_DSSISTLIMPEZ, 'LANCCONT', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'LANCCONT', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUILANCCONT);

   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     (P_DSSISTLIMPEZ, 'SALDEMPR', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'SALDEMPR', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUISALDEMPR);

   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     (P_DSSISTLIMPEZ, 'LOGLANCONT', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'LOGLANCONT', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUILOGLANCONT);

   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     (P_DSSISTLIMPEZ, 'SALDCOME', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'SALDCOME', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUISALDCOME);

   INSERT INTO LOGLIMPEZA
     (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES
     (P_DSSISTLIMPEZ, 'SALDCCUS', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'SALDCCUS', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUISALDCCUS);      

   DELETE FROM LISTA
    WHERE NRLISTA =P_NRLISTA;
    
   COMMIT;
      
EXCEPTION
WHEN OTHERS THEN
   V_ERR0R := SQLERRM(SQLCODE);
   
   IF INSTR(V_ERR0R, 'TIMEOUT - EXCEO PROPOSITAL TEKNISA') = 0 THEN
      DELETE FROM LISTA
       WHERE NRLISTA =P_NRLISTA; 
      
      UPDATE TRABLIMPEZA
         SET IDSTATUSLIMPEZA = 'C'
       WHERE IDLIMPEZA = P_IDSISTEMA;
       
      COMMIT;
   ELSE
      UPDATE TRABLIMPEZA
         SET IDSTATUSLIMPEZA = 'P'
       WHERE IDLIMPEZA = P_IDSISTEMA;  
   END IF;  

   IF (V_EXCLUILANCCONT > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        (P_DSSISTLIMPEZ, 'LANCCONT', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'LANCCONT', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUILANCCONT);
   END IF;

   IF (V_EXCLUISALDEMPR > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        (P_DSSISTLIMPEZ, 'SALDEMPR', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'SALDEMPR', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUISALDEMPR);
   END IF;

   IF (V_EXCLUILOGLANCONT > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        (P_DSSISTLIMPEZ, 'LOGLANCONT', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'LOGLANCONT', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUILOGLANCONT);
   END IF;

   IF (V_EXCLUISALDCOME > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        (P_DSSISTLIMPEZ, 'SALDCOME', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'SALDCOME', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUISALDCOME);
   END IF;

   IF (V_EXCLUISALDCCUS > 0) THEN
      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
      VALUES
        (P_DSSISTLIMPEZ, 'SALDCCUS', SYSDATE, P_NMOPERLIMPEZ, P_DTLANC, 'SALDCCUS', V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_EXCLUISALDCCUS);
   END IF;
   
   COMMIT;
   
   RAISE_APPLICATION_ERROR (-20101, 'PASSO : ' || V_PASSO || '   -   ' || V_ERR0R);

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LIMPEZA_LANCCONT','4.09.090'); END;
/